/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public virtual Result Execute(ExternalCommandData commandData , ref string message, ElementSet elements) { try { Document document = commandData.Application.ActiveUIDocument.Document; ICollection <ElementId> datums = commandData.Application.ActiveUIDocument.Selection.GetElementIds(); Autodesk.Revit.DB.View view = commandData.Application.ActiveUIDocument.ActiveView; if (datums == null || datums.Count == 0) { return(Result.Cancelled); } //// Show UI using (DatumStyleSetting settingForm = new DatumStyleSetting()) { if (settingForm.ShowDialog() == DialogResult.OK) { using (Transaction tran = new Transaction(document, "StyleModification")) { tran.Start(); foreach (ElementId datumRef in datums) { DatumPlane datum = document.GetElement(datumRef) as DatumPlane; if (showLeftBubble) { datum.ShowBubbleInView(DatumEnds.End0, view); } else { datum.HideBubbleInView(DatumEnds.End0, view); } if (showRightBubble) { datum.ShowBubbleInView(DatumEnds.End1, view); } else { datum.HideBubbleInView(DatumEnds.End1, view); } if (changeLeftEnd2D) { datum.SetDatumExtentType(DatumEnds.End0, view, DatumExtentType.ViewSpecific); } else { datum.SetDatumExtentType(DatumEnds.End0, view, DatumExtentType.Model); } if (changeRightEnd2D) { datum.SetDatumExtentType(DatumEnds.End1, view, DatumExtentType.ViewSpecific); } else { datum.SetDatumExtentType(DatumEnds.End1, view, DatumExtentType.Model); } if (addLeftElbow && datum.GetLeader(DatumEnds.End0, view) == null) { datum.AddLeader(DatumEnds.End0, view); } else if (datum.GetLeader(DatumEnds.End0, view) != null) { Leader leader = datum.GetLeader(DatumEnds.End0, view); leader = CalculateLeader(leader, addLeftElbow); datum.SetLeader(DatumEnds.End0, view, leader); } if (addRightElbow && datum.GetLeader(DatumEnds.End1, view) == null) { datum.AddLeader(DatumEnds.End1, view); } else if (datum.GetLeader(DatumEnds.End1, view) != null) { Leader leader = datum.GetLeader(DatumEnds.End1, view); leader = CalculateLeader(leader, addRightElbow); datum.SetLeader(DatumEnds.End1, view, leader); } } tran.Commit(); } } } return(Result.Succeeded); } catch (Exception ex) { message = ex.Message; return(Result.Failed); } }
public Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements) { UIDocument uidoc = commandData.Application.ActiveUIDocument; Document doc = uidoc.Document; try { using (Transaction t = new Transaction(doc, "Correct grid bubbles")) { t.Start(); foreach (ElementId elemId in uidoc.Selection.GetElementIds()) { Element SelectedElem = doc.GetElement(elemId); if (SelectedElem is DatumPlane) { DatumPlane xGrid = SelectedElem as DatumPlane; IList <Curve> CurvesInGrid = xGrid.GetCurvesInView(DatumExtentType.ViewSpecific, uidoc.ActiveView); Curve cv = CurvesInGrid.First(); // only one segment grids allowed XYZ cvStart = cv.GetEndPoint(0); XYZ cvEnd = cv.GetEndPoint(1); XYZ cvTop = null; XYZ cvLeft = null; #region FIND TOP AND LEFT if (Convert.ToInt32(cvStart.Y) == Convert.ToInt32(cvEnd.Y)) // then its a horizontal line { if (cvStart.X < cvEnd.X) // drawn left to right, keep start X---------> { cvLeft = cvStart; } else if (cvStart.X > cvEnd.X) // drawn right to left, keep end <---------X { cvLeft = cvEnd; } } else if (Convert.ToInt32(cvStart.X) == Convert.ToInt32(cvEnd.X)) // then its a vertical { if (cvStart.Y < cvEnd.Y) // drawn bottom to top, keep end { cvTop = cvEnd; } else if (cvStart.Y > cvEnd.Y) // drawn top to bottom, keep start { cvTop = cvStart; } } #endregion // Use top and left, and start and end to find which endpoint to turn on if ((cvLeft != null && cvLeft.IsAlmostEqualTo(cvStart)) || (cvTop != null && cvTop.IsAlmostEqualTo(cvStart))) // the grid was drawn correctly { xGrid.ShowBubbleInView(DatumEnds.End0, uidoc.ActiveView); xGrid.HideBubbleInView(DatumEnds.End1, uidoc.ActiveView); } else if ((cvLeft != null && cvLeft.IsAlmostEqualTo(cvEnd)) || cvTop != null && cvTop.IsAlmostEqualTo(cvEnd)) // the grid was drawn the other way around { xGrid.ShowBubbleInView(DatumEnds.End1, uidoc.ActiveView); xGrid.HideBubbleInView(DatumEnds.End0, uidoc.ActiveView); } } } t.Commit(); } return(Result.Succeeded); } catch (Exception ex) { Utils.CatchDialog(ex); return(Result.Failed); } }